<!doctype html>
<html>

<head>
    <title>BeneClientAPI sample</title>
    <script src="jquery.min.js"></script>
    <script src="underscore.min.js"></script>
    
<script>
$(document).ready(function(){

    // Persistable config
    $.each(["addr", "tgt", "bnum"], function processPersistableCfg(i, name){
        var selector = "[name=" + name + "]";
        try {
            var v = localStorage.getItem(name);
            if(v && v.length > 0){
                $(selector).val(v)
            }
        } catch(exc){
            console.error("Error accessing localStorage. Stored config not loaded", exc)
        }
        
        $(selector).on("change", function onPersistableChanged(ev){
            try {
                localStorage.setItem(name, $(ev.target).val());
            } catch(exc){
                console.error("Error accessing localStorage. Config will not be stored", exc)
            }
        });
    });
    
    
    var transactionHilight = function transactionHilight(element, hilight){            
            var c = "hilight";
            
            var t_id = element.attr("data-transaction");
            if(t_id > 0){
                var targets = element
                    .siblings("[data-transaction=" + t_id + "]")
                    .add(element);
                    
                if(hilight) {
                    targets.addClass(c);
                } else {
                    targets.removeClass(c);
                }
            }
    };
    // Hilight transaction on hover
    $("#console")
        .height($(window).height() - 100)
        .on("mouseenter", ".message", function onMouseEnterMessage(ev){
            transactionHilight($(ev.target), true);
        })
        .on("mouseleave", ".message", function onMouseLeaveMessage(ev){
            transactionHilight($(ev.target), false);
        });
    
    
    // Logger for outputting to both DOM and console
    var logger = {
        _print: function print(data, type){
            var console = $("#console");
            
            var args = _.map(data, function(x){
                if(_.isObject(x)){
                    return JSON.stringify(x);
                } else {
                    return x;
                }
            });
            
            var transaction_id = _.without(
                _.map(args, function findData(x){
                    try {
                        var d = JSON.parse(x);
                        
                        if(d.id) {
                            return d.id;
                        }
                    } catch(exc) { } 
                }),
                undefined
            );
              
            var msg = 
                $("<span class='message' />")
                    .addClass(type)
                    .html(args.join(" "))
                    .prepend(
                        $("<span class='timestamp' />")
                            .text((new Date()).toISOString().substring(11, 19))
                    );
                    
            if(transaction_id > 0){
                msg.attr("data-transaction", transaction_id);
            }
                    
                    
            msg.appendTo(console);
                
            // Don't let too many elements linger
            if(console.children().length > 500) {
                console.children().slice(0, console.children().length - 500).remove();
            }
                
                
            // Scroll console to bottom
            console[0].scrollTop = console[0].scrollHeight;
        },
        
        // Log info level
        info: function log(){
            var args = Array.prototype.slice.call(arguments);
            console.log(args);
            logger._print(args, "info");
        },
        // Log error
        error: function error(){
            var args = Array.prototype.slice.call(arguments);
            console.error(args);
            logger._print(args, "error");
        },
        debug: function debug(){
            var args = Array.prototype.slice.call(arguments);
            console.info(args);
            logger._print(args, "debug");
        }
    }
    
    // Client library
    var BeneAPIClientFactory = function getClient(logger) {
        var c = {
            // Request identifier
            g: Date.now(),
            logger: logger,
            
            // Managed socket
            socket: null,
            
            addr: null,
            
            // Integration target, softphone/lync
            _tgt: "softphone",
            
            // Requested callbacks
            // Contains objects:
            // {id: related requets, cb: callback func}
            callbacks: [],
            
            // Connect websocket
            connect: function connect(addr, tgt) {
            
                // Close existing socket
                if(c.socket) {
                    c.logger.debug("Closing previous socket");
                    c.socket.onclose = function() {
                        c.logger.debug("Previous socket closed");
                        console.log("PREV SOCKET CLOSED");
                    };
                    c.socket.close();
                    c.socket = null;
                }
            
                c.addr = addr;
                c.logger.info("###########################");
                c.logger.info("Initializing new connection");
                
                c._tgt = tgt;
                
                try {
                    c.socket = new WebSocket(c.addr);
                }
                catch(exc) {
                    c.logger.error("Connection failed");
                    c._reconnect();
                }
                // Bind event handlers
                c.socket.onopen = c.sockethandlers.onopen;
                c.socket.onclose = c.sockethandlers.onclose;
                c.socket.onerror = c.sockethandlers.onerror;
                c.socket.onmessage = c.sockethandlers.onmessage;
                
                
                var timeout = setTimeout(function checkForConnectionTimeout(){
                    if(c.socket.readyState != 1){
                        c.logger.error("Connection timed out");
                        c.socket.close();
                    }
                }, 60 * 1000);
                
            },
                        
            _reconnect: function reconnect() {                
                setTimeout(function(){
                    c.logger.debug("Attempting to reconnect..");
                    c.connect(c.addr, c._tgt);
                }, 5 * 1000);
            },
            
            _pingpongTimeout: -1,
            // Set up keepalive to keep socket open if nothing happens
            _pingpong: function pingpong(){
            
                // Clear previous timeout if set
                if(c._pingpongTimeout > -1){
                    clearTimeout(c._pingpongTimeout);
                }
            
                c.methods.getState();
                
                c._pingpongTimeout = setTimeout(function(){
                    c._pingpong();
                }, 30 * 1000);
            },
            
            _initAfterOpen: function init(){
                // Do init things after socket is open
                if(c._tgt && c._tgt != "default") {
                    var data = c.buildmessage("Init", [c._tgt]);
                    c.send(data, function onInitComplete(){
                        c.logger.info("Working in mode " + c._tgt);
                    });
                } else {
                    c.logger.info("Init not specified, running in default mode");
                }
            },
            
            // Send given data, mapping callback if provided
            send: function send(data, cb){
                if(c.socket.readyState != 1) {
                    c.logger.error("Socket not open, message discarded");
                    return;
                }
            
                // Set callback
                if (_.isFunction(cb)) {
                    c.callbacks.push( { id: data.id, cb: cb} );
                }
                
                var d = JSON.stringify(data);
                c.logger.debug("Sending", d);
                c.socket.send(d);
            },
            
            // Build data for jsonrpc
            buildmessage: function buildMessage(method, params){
              return {
                    jsonrpc: "2.0",
                    id: c.g++,
                    params: params,
                    method: method
                };  
            },
            
            _listeners: {
                open: [],
                close: [],
                error: [],
                message: []
            },
            bind: function bindListener(event, cb){
                c._listeners[event].push(cb);
            },
            
            
            // Handlers for socket events
            sockethandlers: {
                onopen: function onSocketOpen(){
                    c.logger.debug("Socket opened");
                    c._initAfterOpen();
                    c._pingpong();
                    
                    for(var i = 0; i < c._listeners.open.length; i++){
                        c._listeners.open[i]();
                    }
                },
                onclose: function onSocketClose(ev){
                    c.logger.debug("Socked closed. Retrying soon", ev);
                    c._reconnect();
                    
                    for(var i = 0; i < c._listeners.close.length; i++){
                        c._listeners.close[i](ev);
                    }
                },
                onerror: function onSocketError(error){
                    c.logger.error("Error:", error);
                    
                    for(var i = 0; i < c._listeners.error.length; i++){
                        c._listeners.error[i](error);
                    }
                },
                onmessage:function onSocketMessage(ev){
                    
                    var data = JSON.parse(ev.data);
                    
                    // Id set -> is response    
                    if (_.has(data, "id") ) {
                        if(data.error) {
                            c.logger.error("Received error response", data);
                        } else {
                            c.logger.debug("Received response", data);
                        }
                    
                        // Find callback for received message
                        var idx = _.findIndex(c.callbacks,function(x){return x.id === data.id; });                    
                        if (idx > -1) {
                            // Remove and call
                            var cb = c.callbacks.splice(idx, 1)[0];
                            cb.cb(data);
                        }
                    }
                    // Id not set -> is notification
                    else { 
                        c.logger.info("Received notification:", data);
                        
                        
                        if (_.has(c.notifications, data.method)) {
                            c.notifications[data.method](data.params);
                        }
                        
                    }
                    
                    for(var i = 0; i < c._listeners.message.length; i++){
                        c._listeners.message[i](ev);
                    }
                },
            },
            
            // "Public" methods
            methods: {
                // Calls out to target num
                callOut: function callOut(bnum, cb){
                    var data = c.buildmessage("CallOut", [bnum]);
                    c.send(data, cb);
                },
                // Hangs up if there's an ongoing call
                hangup: function hangUp(callId, cb){
                    var data = c.buildmessage("HangUp", []);
                    c.send(data, cb);
                },
                
                // Answers specified call
                answer: function answer(callId, cb){
                    var data = c.buildmessage("Answer", []);
                    c.send(data, cb);
                },
                
                // Get client state. Used when api is initialized to
                // get current status, afterwards notifications are received
                getState: function getState(cb){
                    var data = c.buildmessage("GetState", []);
                    c.send(data, cb);
                },
                
                // Get active calls in client. Used when api is initialized to
                // get current status, afterwards notifications are received
                getActiveCalls: function getActiveCalls(cb){
                    var data = c.buildmessage("GetActiveCalls", []);
                    c.send(data, cb);
                },
            },
            
            // Available notifications
            notifications: {
                CallComing: _.noop,
                CallingOut: _.noop,
                CallConnected: _.noop,
                CallDisconnected: _.noop,
                StateChanged: _.noop,
            }
        };
        return c;
    };
    
    // Init client
    var api = BeneAPIClientFactory(logger);
        
    // When call incoming
    api.notifications.CallComing = function onCallComing(params){
        renderCallState({
            id: params[0],
            num: params[1],
            type: "Incoming",
            state: "Coming",
            timestamp: Date.now(),
        });
    };
    
    // When calling out
    api.notifications.CallingOut = function onCallingOut(params){
        renderCallState({
            id: params[0],
            num: params[1],
            type: "Outbound",
            state: "Calling",
            timestamp: Date.now(),
        });
    };
    
    // When call connects
    api.notifications.CallConnected = function onCallConnected(params){
        renderCallState({
            id: params[0],
            state: "Connected",
            timestamp: Date.now(),
        });
    };
    
    // When call disconnects
    api.notifications.CallDisconnected = function onCallDisconnected(params){
        renderCallState({
            id: params[0],
            state: "Disconnected",
            timestamp: Date.now(),
        });
    };
    
    // When state changes
    api.notifications.StateChanged = function onStateChanged(params){
        renderClientState(params[0]);
    };
    
    // Override onopen to load current client state
    api.bind("open", function onSocketOpened(){
    
        renderClientState("Connected");
        
        // Get client state
        api.methods.getState(function onReceivedState(result){
            renderClientState(result.result);
        });
        
        // Get call state
        api.methods.getActiveCalls(function onReceivedActiveCalls(result){
            var data = result.result;
            
            var callCount = parseInt(data.splice(0, 1)[0]);
            
            for(var i = 0; i < callCount; i++){
                // Next 5 elements from start of array
                var call = data.splice(0, 5);
                
                // Parse date, hange from space-separated to T-separated as required by parser
                ts = Date.parse(call[4].replace(" ", "T"));
                call = {
                    type: call[0],
                    state: call[1],
                    num: call[2],
                    id: call[3],
                    timestamp: ts
                };
                
                renderCallState(call);
            }
        });        
    });
    
    api.bind("close", function onSocketClosed(ev){
        renderClientState("Disconnected");
    });
    
    
    
    var callTmpl = _.template($("#CallTemplate").html());
    
    // Init buttons
    $("#CallForm")
        .on("submit", function(ev){
            ev.preventDefault();
            api.methods.callOut(
                 $("#bnum").val(),
                 function onCallOutComplete(result) {
                     logger.info("onCallOutComplete", result);
                 }
             );
        });
        
    // For rendering client state when it changes
    var renderClientState = function renderClientState(state){
        $("#status").text(state);
    };
    
    // Contain call info
    var calls = {};
    
    // For rendering call states
    // Call should be an object containing following props:
    // type - call type string
    // state - call state string
    // num - other party's number
    // id - call id
    // timestamp - call timestamp
    
    var renderCallState = function renderCallState(call){
        // Get previous info
        if(_.has(calls, call.id)) {
            call = _.extend(calls[call.id], call);
        }
        calls[call.id] = call;
    
    
        var existing = $("#" + call.id);
        
        // Render template, bind, append
        var d = $(callTmpl(call))
        .on("click", "button.Answer", function() {
            api.methods.answer(
                $(this).val(),
                function onAnswerComplete(result){
                    logger.info("onAnswerComplete", result);
                });
        })
        .on("click", "button.Disconnect", function(){                
            api.methods.hangup(
                $(this).val(),
                function onHangupComplete(result){
                   logger.info("onHangupComplete", result); 
                });
        });
        
        if (call.state === "Disconnected") {
            setTimeout(function(){
                d.remove();
            }, 5000);
        }
        
        if(existing.length > 0) {
            existing.replaceWith(d);
        } else {
            d.appendTo("#Calls");
        }
    };
    
    var conn = function connectApi(){
        api.connect( $("#addr").val(), $("#tgt").val());
    };
    
    // Reconnect on param change
    $("body").on("change", "#addr, #tgt", function onParamsChanged(){
        conn();
    });
    
    conn();    
});
</script>
<style>
    body {
        font-family: monospace;
        background: #222;
        color: #eee;
    }
    h1, h2, h3, h4, h5 {
        color: #f08526;
    }
	a {
		color: #eee;
	}
    
    #client {
        background: #333;
        padding: 1em;
        max-width: 25%;
        
        border-radius: 3px;
        float: left;
        clear: none;
    }
    
    #header {
        width: 100%;
    }
    #header img {
        width: 60%;
    }
    #header label {
        width: 100%;
        display: block;        
    }
    #header input {
        width: 100%;
        display: block;
    }
    #header #statusdisplay {
        position: relative;
        top: 0;
        right: 0;
    }
    
    #console {
        width: 70%;
        float: left;
        clear: none;
        border-radius: 3px;
        
        padding: 0.5em;
        margin: 0.5em;
        
        background: #333;
        font-family: monospace;
        overflow-y: scroll;
        overflow-x: hidden;
    }    
    #console .message {
        display: block;
        border-bottom: solid rgba(240,133,38,0.5) 1px;
    }    
    #console .message .timestamp {
        margin-right: 1em;
        font-family: monospace;
    }    
    #console .message.info {
    }
    #console .message.error {
        color: red;
    }
    #console .message.debug {
        color: #aaa;
    }
    #console .message.hilight {
        background: #666;
        color: white;
    }
    
    #Calls .Call {
        border: solid #999 1px;
        border-radius: 3px;
    }
</style>
</head>
<body>
    <div id="client">
        <div id="header">
            <img src="logo.svg" />
            <h1>Voice for Windows ClientAPI Tester</h1>
            <p>
                <a href="https://gitlab.com/benemen/public/clientapi-sample">Source code in GitLab</a>
            </p>

            <label for="addr">Websocket address</label>
            <input type="text" name="addr" id="addr" value="wss://localhost.benedesk.com:9898/" />
            
            <label for="tgt">Integrated component</label>
            <select name="tgt" id="tgt">
                <option value="lync">Lync/Skype</option>
                <option value="softphone">Softphone</option>
                <option value="default">Default</option>
            </select>
            
            <p>
            <span id="statusdisplay">Client status:<span id="status">-unknown-</span></span>
            </p>
        </div>
        
        <div id="controls">
            <div>
                <h2>New call</h2>
                <form id="CallForm">
                    <input type="tel" id="bnum" name="bnum" />
                    <button type="submit">Call</button>
                </form>
            </div>
            <div id="Calls">
                
            </div>
        </div>
    </div>
    <div id="console"></div>

</body>

<script type="text/html" id="CallTemplate">
<div class="Call" id="<%-id%>">
    <h3>Call:
        <span class="type"><%-type%></span>
        <span class="state"><%-state%></span>
    </h3>
    
    <div>To <span class="num"><%-num%></span></div>
    <div>Changed: <span class="timestamp"><%-timestamp%></span></div>
    <%if(type=="Incoming"&&state=="Coming"){%>
        <button class="Answer" type="button" value="<%-id%>">Answer</button>
    <%}%>
    <button class="Disconnect" type="button" value="<%-id%>">Disconnect</button>
</div>
</script>

</html>